<template>
  <v-row class="pa-7" dense>
    <v-col cols="12" md="12">
      <v-card
        variant="outlined"
        class="mx-auto"
        color="surface-variant"
        hight="500px"
      >
        <v-list-item class="pa-6">
          <template v-slot:append>
            <v-dialog persistent max-width="800">
              <template v-slot:activator="{ props: activatorProps }">
                <v-btn
                  v-bind="activatorProps"
                  append-icon="$vuetify"
                  color="success"
                >
                  Add
                </v-btn>
              </template>
              <template v-slot:default="{ isActive }">
                <v-card>
                  <br />
                  <v-container>
                    <v-row no-gutters>
                      <v-col cols="12" sm="4">
                        <v-sheet class="ma-2 pa-2"> Name : </v-sheet>
                      </v-col>
                      <v-col cols="12" sm="4">
                        <v-sheet>
                          <v-text-field
                            v-model="name"
                            label="name"
                            variant="outlined"
                            dense
                            hide-details="auto"
                          ></v-text-field>
                        </v-sheet>
                      </v-col>
                      <v-col cols="12" sm="4">
                        <v-sheet class="ma-2 pa-2">
                          <v-btn
                            @click="save"
                            append-icon="$vuetify"
                            color="success"
                          >
                            SAVE
                          </v-btn>
                        </v-sheet>
                      </v-col>
                    </v-row>
                  </v-container>
                  <v-row cols="12">
                    <v-col cols="12" sm="6">
                      <div class="col-3 pa-7">
                        <v-card
                          variant="outlined"
                          class="mx-auto pa-5"
                          color="surface-variant"
                        >
                          <draggable
                            class="list-group"
                            :list="list1"
                            group="people"
                            itemKey="name"
                          >
                            <template #item="{ element }">
                              <v-card
                                variant="outlined"
                                class="mx-auto pa-4 ma-2"
                                color="surface-variant"
                              >
                                <div class="list-group-item">
                                  {{ element.name }}
                                </div>
                              </v-card>
                            </template>
                          </draggable>
                        </v-card>
                      </div>
                    </v-col>
                    <v-col cols="12" sm="6">
                      <div class="col-3 pa-7">
                        <v-card
                          variant="outlined"
                          class="mx-auto pa-5"
                          color="surface-variant"
                        >
                          <draggable
                            class="list-group"
                            :list="list2"
                            group="people"
                            @change="itemData"
                            itemKey="name"
                          >
                            <template #item="{ element }">
                              <v-card
                                variant="outlined"
                                class="mx-auto pa-4 ma-2"
                                color="surface-variant"
                              >
                                <div class="list-group-item">
                                  {{ element.name }}
                                </div>
                              </v-card>
                            </template>
                          </draggable>
                        </v-card>
                      </div>
                    </v-col>
                  </v-row>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn
                      text="Close Dialog"
                      @click="isActive.value = false"
                    ></v-btn>
                  </v-card-actions>
                </v-card>
              </template>
            </v-dialog>
          </template>
        </v-list-item>

        <v-table>
          <thead>
            <tr>
              <th class="text-left">Name</th>
              <th class="text-left"></th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="item in data.item" :key="item._id">
              <td class="pa-2">{{ item.name }}</td>
              <td class="pa-2" width="10">
                <v-btn @click="funcView(item._id)"> view </v-btn>
              </td>
              <td class="pa-2" width="10">
                <v-btn @click="funcEdit(item._id)"> edit </v-btn>
              </td>
              <td class="pa-2" width="10">
                <v-btn @click="funcDelete(item._id)"> delete </v-btn>
              </td>
            </tr>
          </tbody>
        </v-table>
      </v-card>
    </v-col>
  </v-row>

  <v-dialog v-model="view" width="500">
    <v-card>
      <v-btn class="ms-auto ma-3" text="Close" @click="view = false"></v-btn>
      <v-container>
        <v-row>
          <v-col cols="12" sm="6">
            <v-sheet class="pa-2"> {{ data_detail?.text?.name }} </v-sheet>
          </v-col>
          <v-col cols="12" sm="6">
            <v-sheet  class="pa-2"> {{ data_detail?.date?.name }} </v-sheet>
          </v-col>
        </v-row>
      </v-container>
    </v-card>
  </v-dialog>

  <v-dialog v-model="edit" width="500">
    <v-card>
      <template v-slot:append>
        <v-btn class="ms-auto ma-3" text="Close" @click="edit = false"></v-btn>
        <v-btn class="ms-auto ma-3" text="Save" @click="saveEdit()"></v-btn>
      </template>
      <v-container>
        <v-row cols="12">
          <v-col cols="12" sm="6">
            <div class="col-3 pa-7">
              <v-card
                variant="outlined"
                class="mx-auto pa-5"
                color="surface-variant"
              >
                <draggable
                  class="list-group"
                  :list="list1"
                  group="people"
                  itemKey="name"
                >
                  <template #item="{ element }">
                    <v-card
                      variant="outlined"
                      class="mx-auto pa-4 ma-2"
                      color="surface-variant"
                    >
                      <div class="list-group-item">
                        {{ element.name }}
                      </div>
                    </v-card>
                  </template>
                </draggable>
              </v-card>
            </div>
          </v-col>
          <v-col cols="12" sm="6">
            <div class="col-3 pa-7">
              <v-card
                variant="outlined"
                class="mx-auto pa-5"
                color="surface-variant"
              >
                <draggable
                  class="list-group"
                  :list="list2"
                  group="people"
                  @change="itemData"
                  itemKey="name"
                >
                  <template #item="{ element }">
                    <v-card
                      variant="outlined"
                      class="mx-auto pa-4 ma-2"
                      color="surface-variant"
                    >
                      <div class="list-group-item">
                        {{ element.name }}
                      </div>
                    </v-card>
                  </template>
                </draggable>
              </v-card>
            </div>
          </v-col>
        </v-row>
      </v-container>
    </v-card>
  </v-dialog>
</template>
<script>
import ApiService from "@/services/apiService";
import draggable from "vuedraggable";
import moment from "moment";
import { isProxy, toRaw } from "vue";
export default {
  name: "two-lists",
  display: "Two Lists",
  order: 1,
  components: {
    draggable,
  },
  data() {
    return {
      view: false,
      edit: false,
      delete: false,
      list1: [
        { name: "Text test 1", type: "text" },
        { name: moment().format("DD/MM/YYYY"), type: "date" },
      ],
      name: "",
      list2: [],
      data: [],
      data_detail: "",
      delete_detail: "",
      rawData: [],
    };
  },
  created() {
    this.first();
  },
  methods: {
    first: function () {
      let item = {
        page: 1,
        limit: 10,
        search: "",
      };
      ApiService.list(item)
        .then((response) => {
          this.data = response.data;
        })
        .catch((error) => {
          console.error("Error fetching data:", error);
        });
    },
    itemData: function () {
      this.rawData = this.list2;
      if (isProxy(this.list2)) {
        this.rawData = toRaw(this.list2);
      }
    },
    funcView: function (id) {
      console.log("funcView")
      this.view = true;
      ApiService.detail(id)
        .then((response) => {
          this.data_detail = response.data;
        })
        .catch((error) => {
          console.error("Error fetching data:", error);
        });
    },
    funcEdit: function (id) {
      this.edit = true;
      ApiService.detail_edit(id)
        .then((response) => {
          this.delete_detail = response.data;
          this.list2 = response.data.item;
          let c = [];
          for (var i = 0; i < this.list1.length; i++) {
            var found = false;
            for (var j = 0; j < this.list2.length; j++) {
              if (
                JSON.stringify(this.list1[i]) === JSON.stringify(this.list2[j])
              ) {
                found = true;
                break;
              }
            }
            if (!found) {
              c.push(this.list1[i]);
            }
          }
          this.list1 = toRaw(c);
        })
        .catch((error) => {
          console.error("Error fetching data:", error);
        });
    },
    saveEdit: function () {
      const id = this.delete_detail._id;
      const item = toRaw(this.rawData);
      ApiService.edit(id, item)
        .then((response) => {
          this.data_detail = response.data;
          this.edit = false;
          this.list1 = [
            { name: "Text test 1", type: "text" },
            { name: moment().format("DD/MM/YYYY"), type: "date" },
          ];
          this.first();
        })
        .catch((error) => {
          console.error("Error fetching data:", error);
        });
    },
    funcDelete: function (id) {
      this.delete = true;
    },
    save: function () {
      let rawData = this.list2;
      if (isProxy(this.list2)) {
        rawData = toRaw(this.list2);
      }
      const item = {
        name: this.name,
        item: rawData,
      };
      ApiService.create(item)
        .then((response) => {
          this.data = response.data;
        })
        .catch((error) => {
          console.error("Error fetching data:", error);
        });
    },
    funcDelete : function (id) {
       ApiService.delete(id)
        .then((response) => {
           this.first();
        })
        .catch((error) => {
          console.error("Error fetching data:", error);
        });
    }
  },
};
</script>